local module = { };
local _G = getfenv(0);
local MODULE_NAME = "Steak Timer";
local MODULE_VERSION = strmatch(GetAddOnMetadata(MODULE_NAME, "version"), "^([%d.]+)");
module.name = MODULE_NAME;
module.version = MODULE_VERSION;
_G[MODULE_NAME] = module;
CT_Library:registerModule(module);
local opts = {};
SteakTimer.alpha = nil;
SteakTimer.alphaUpdate = nil;
SteakTimer.alphaWait = nil;
SteakTimer.color = nil;
SteakTimer.countfrom = nil;
SteakTimer.hideBG = nil;
SteakTimer.position = nil;
SteakTimer.show = nil;
SteakTimer.showsecs = nil;
SteakTimer.status = nil;
SteakTimer.step = nil;
SteakTimer.time = nil;
SteakTimer_CallFunctions = { };
function SteakTimer_OnMouseOver()
	SteakTimerFrameDragClickFrame.step = 0.05;
end
function SteakTimer_OnMouseOut()
	SteakTimerFrameDragClickFrame.step = -0.05;
end
function SteakTimer_Toggle(frame)
	if ( SteakTimerData.status and SteakTimerData.status == 1 ) then
		SteakTimerData.status = 0;
		_G[frame:GetName() .. "Time"]:SetTextColor(1, 0.5, 0);
		SteakTimerData.color = { 1, 0.5, 0 };
	else
		if ( not SteakTimerData.status ) then
			if ( SteakTimerData.time > 0 ) then
				SteakTimerData.countfrom = SteakTimer_GetTimeString(SteakTimerData.time);
				SteakTimerData.step = -1;
			else
				SteakTimerData.step = 1;
			end
		end
		_G[frame:GetName() .. "Time"]:SetTextColor(0, 1, 0);
		SteakTimerData.color = { 0, 1, 0 };
		SteakTimerData.status = 1;
	end
end
function SteakTimer_UpdateTime(self, elapsed)
	if ( opts.hideBG ) then
		SteakTimerData.alphaUpdate = ( SteakTimerData.alphaUpdate or 0 ) + elapsed;
		if ( SteakTimerData.alphaUpdate > 0.05 ) then
			if ( ( not SteakTimerData.alphaWait or SteakTimerData.alphaWait < 1 ) and ( SteakTimerFrameDragClickFrame.step or 0 ) > 0 ) then
				SteakTimerData.alphaWait = ( SteakTimerData.alphaWait or 0 ) + elapsed;
				SteakTimerFrameHeaderTexture:SetAlpha(0);
				SteakTimerFrameScrollDownHour:SetAlpha(0);
				SteakTimerFrameScrollDownMin:SetAlpha(0);
				SteakTimerFrameScrollUpHour:SetAlpha(0);
				SteakTimerFrameScrollUpMin:SetAlpha(0);
			else
				SteakTimerData.alpha = ( SteakTimerData.alpha or 0 ) + ( SteakTimerFrameDragClickFrame.step or 0 );
				if ( SteakTimerData.alpha < 0 ) then
					SteakTimerData.alpha = 0;
					SteakTimerData.alphaWait = nil;
				elseif ( SteakTimerData.alpha > 1 ) then
					SteakTimerData.alpha = 1;
				end
				SteakTimerFrameHeaderTexture:SetAlpha(SteakTimerData.alpha);
				SteakTimerFrameScrollDownHour:SetAlpha(SteakTimerData.alpha);
				SteakTimerFrameScrollDownMin:SetAlpha(SteakTimerData.alpha);
				SteakTimerFrameScrollUpHour:SetAlpha(SteakTimerData.alpha);
				SteakTimerFrameScrollUpMin:SetAlpha(SteakTimerData.alpha);
			end
		end
	else
		SteakTimerData.alpha = nil;
		SteakTimerData.alphaWait = nil;
		SteakTimerData.alphaUpdate = nil;
		SteakTimerFrameHeaderTexture:SetAlpha(1);
		SteakTimerFrameScrollDownHour:SetAlpha(1);
		SteakTimerFrameScrollDownMin:SetAlpha(1);
		SteakTimerFrameScrollUpHour:SetAlpha(1);
		SteakTimerFrameScrollUpMin:SetAlpha(1);
	end
	if ( not SteakTimerData.status or SteakTimerData.status == 0 ) then
		if ( SteakTimerData.color ) then
			SteakTimerFrameTime:SetTextColor(SteakTimerData.color[1], SteakTimerData.color[2], SteakTimerData.color[3]);
		end
		return;
	end
	SteakTimerFrame.update = ( SteakTimerFrame.update or 0 ) + elapsed;
	if ( SteakTimerFrame.update >= 1 ) then
		if ( SteakTimerData.color ) then
			SteakTimerFrameTime:SetTextColor(SteakTimerData.color[1], SteakTimerData.color[2], SteakTimerData.color[3]);
		end
		SteakTimerData.time = SteakTimerData.time + SteakTimerData.step;
		for k, v in pairs(SteakTimer_CallFunctions) do
			if ( type(v) == "function" ) then
				v(SteakTimerData.time, SteakTimerData.step);
			end
		end
		if ( SteakTimerData.time == 0 ) then
			DEFAULT_CHAT_FRAME:AddMessage(format(SteakTimer_FINISHCOUNT, SteakTimerData.countfrom), 1, 0.5, 0);
			PlaySound("TellMessage");
			SteakTimer_Reset();
		else
			SteakTimer_SetTime(SteakTimerData.time, SteakTimerFrame);
		end
		SteakTimerFrame.update = SteakTimerFrame.update - 1;
	end
end
function SteakTimer_Start(seconds)
	SteakTimerData.status = 1;
	if ( seconds ) then
		SteakTimerData.step = -1;
		SteakTimerData.countfrom = SteakTimer_GetTimeString(seconds);
	else
		SteakTimerData.step = 1;
	end
	if ( seconds ) then
		SteakTimerData.time = seconds;
	else
		SteakTimerData.time = 0;
	end
	SteakTimerFrameTime:SetTextColor(0, 1, 0);
	SteakTimerData.color = { 0, 1, 0 };
end
function SteakTimer_Pause(newStatus)
	if ( not newStatus and ( not SteakTimerData.status or SteakTimerData.status == 0 ) ) then
		newStatus = 1;
	elseif ( newStatus and newStatus ~= 0 and newStatus ~= 1 ) then
		newStatus = nil;
	end
	if ( newStatus ) then
		if ( not SteakTimerData.status ) then
			if ( SteakTimerData.time > 0 ) then
				SteakTimerData.countfrom = SteakTimer_GetTimeString(SteakTimerData.time);
				SteakTimerData.step = -1;
			else
				SteakTimerData.step = 1;
			end
		end
		SteakTimerData.status = 1;
		SteakTimerFrameTime:SetTextColor(0, 1, 0);
		SteakTimerData.color = { 0, 1, 0 };
	else
		SteakTimerData.status = 0;
		SteakTimerFrameTime:SetTextColor(1, 0.5, 0);
		SteakTimerData.color = { 1, 0.5, 0 };
	end
end
function SteakTimer_SetTime(num, field)
	if ( not num ) then
		return;
	end
	local hours, mins, secs, temp;
	if ( num >= 3600 ) then
		hours = floor(num / 3600);
		temp = num - (hours*3600);
		mins = floor(temp / 60);
		secs = temp - (mins*60);
	elseif ( num >= 60 ) then
		hours = 0;
		mins = floor(num / 60);
		secs = num - (mins*60);
	else
		hours = 0;
		mins = 0;
		secs = num;
	end
	if ( not opts.showSeconds ) then
		_G[field:GetName() .. "Time"]:SetText(SteakTimer_AddZeros(hours) .. ":" .. SteakTimer_AddZeros(mins));
	else
		_G[field:GetName() .. "Time"]:SetText(SteakTimer_AddZeros(hours) .. ":" .. SteakTimer_AddZeros(mins) .. ":" .. SteakTimer_AddZeros(secs));
	end
	if ( SteakTimerData.time < 60 ) then
		SteakTimerFrameScrollDownMin:Disable();
		SteakTimerFrameScrollDownHour:Disable();
	elseif ( SteakTimerData.time < 3600 ) then
		SteakTimerFrameScrollDownHour:Disable();
		SteakTimerFrameScrollDownMin:Enable();
	else
		SteakTimerFrameScrollDownMin:Enable();
		SteakTimerFrameScrollDownHour:Enable();
	end
end
function SteakTimer_GetTimeString(num)
	local hours, mins, secs;
	if ( num >= 3600 ) then
		hours = floor(num / 3600);
		mins = floor(mod(num, 3600) / 60);
	else
		hours = 0;
		mins = floor(num / 60);
	end
	if ( hours == 0 ) then
		if ( mins == 1 ) then
			return "1 " .. SteakTimer_MIN;
		else
			return mins .. " " .. SteakTimer_MINS;
		end
	else
		local str;
		if ( hours == 1 ) then
			str = "1 " .. SteakTimer_HOUR;
		else
			str = hours .. " " .. SteakTimer_HOURS;
		end
		if ( mins == 0 ) then
			return str;
		elseif ( mins == 1 ) then
			return str .. " and 1 " .. SteakTimer_MIN;
		else
			return str .. " and " .. mins .. SteakTimer_MINS;
		end
	end
end
function SteakTimer_AddZeros(num)
	if ( strlen(num) == 1 ) then
		return "0" .. num;
	elseif ( strlen(num) == 2 ) then
		return num;
	else
		return "--";
	end
end
function SteakTimer_ModTime(self, num)
	SteakTimerData.time = SteakTimerData.time + num;
	if ( SteakTimerData.time < 0 ) then
		SteakTimerData.time = 0;
	end
	SteakTimer_SetTime(SteakTimerData.time, self:GetParent());
end
function SteakTimer_SetTimerTime(num)
	if ( num < 0 ) then
		num = 0;
	end
	SteakTimerData.time = num;
	SteakTimer_SetTime(SteakTimerData.time, SteakTimerFrame);
end
function SteakTimer_Reset()
	SteakTimerFrameTime:SetTextColor(1, 0, 0);
	SteakTimerData.color = { 1, 0, 0 };
	SteakTimerData.status = nil;
	SteakTimerData.time = 0;
	SteakTimerData.countfrom = nil;
	SteakTimer_SetTime(SteakTimerData.time, SteakTimerFrame);
end
SlashCmdList["TIMER"] = function(msg)
	msg = strlower(msg);
	if ( msg == "" ) then
		DEFAULT_CHAT_FRAME:AddMessage("<CTMod> " .. SteakTimer_HELP[1], 1, 1, 0);
		DEFAULT_CHAT_FRAME:AddMessage("<CTMod> " .. SteakTimer_HELP[2], 1, 1, 0);
		DEFAULT_CHAT_FRAME:AddMessage("<CTMod> " .. SteakTimer_HELP[3], 1, 1, 0);
		DEFAULT_CHAT_FRAME:AddMessage("<CTMod> " .. SteakTimer_HELP[4], 1, 1, 0);
		DEFAULT_CHAT_FRAME:AddMessage("<CTMod> " .. SteakTimer_HELP[5], 1, 1, 0);
		DEFAULT_CHAT_FRAME:AddMessage("<CTMod> " .. SteakTimer_HELP[6], 1, 1, 0);
		DEFAULT_CHAT_FRAME:AddMessage("<CTMod> " .. SteakTimer_HELP[7], 1, 1, 0);
		DEFAULT_CHAT_FRAME:AddMessage("<CTMod> " .. SteakTimer_HELP[8], 1, 1, 0);
		DEFAULT_CHAT_FRAME:AddMessage("<CTMod> " .. SteakTimer_HELP[9], 1, 1, 0);
		DEFAULT_CHAT_FRAME:AddMessage("<CTMod> " .. SteakTimer_HELP[10], 1, 1, 0);
	elseif ( msg == "show" ) then
		DEFAULT_CHAT_FRAME:AddMessage("<CTMod> " .. SteakTimer_SHOW_ON, 1, 1, 0);
		SteakTimerFrame:Show();
		opts.showTimer = 1;
	elseif ( msg == "hide" ) then
		DEFAULT_CHAT_FRAME:AddMessage("<CTMod> " .. SteakTimer_SHOW_OFF, 1, 1, 0);
		SteakTimerFrame:Hide();
		opts.showTimer = nil;
		SteakTimer_ShowTimer = 0;
	elseif ( msg == "secs on" ) then
		opts.showSeconds = 1;
		DEFAULT_CHAT_FRAME:AddMessage("<CTMod> " .. SteakTimer_SHOWSECS_ON, 1, 1, 0);
		SteakTimer_SetTime(SteakTimerData.time, SteakTimerFrame);
	elseif ( msg == "secs off" ) then
		opts.showSeconds = nil;
		DEFAULT_CHAT_FRAME:AddMessage("<CTMod> " .. SteakTimer_SHOWSECS_OFF, 1, 1, 0);
		SteakTimer_SetTime(SteakTimerData.time, SteakTimerFrame);
	elseif ( msg == "start" ) then
		SteakTimer_Start();
	elseif ( msg == "stop" ) then
		SteakTimer_Pause();
	elseif ( msg == "reset" ) then
		SteakTimer_Reset();
	elseif ( msg == "bg on" ) then
		opts.hideBG = nil;
		SteakTimerData.alphaUpdate = 5;
	elseif ( msg == "bg off" ) then
		opts.hideBG = 1;
		SteakTimerData.alphaUpdate = 5; 
	elseif ( string.find(msg, "^%d+$") ) then
		local _, _, mins = string.find(msg, "^(%d+)$");
		SteakTimer_Start(tonumber(mins)*60);
	elseif ( string.find(msg, "^%d+:%d+$") ) then
		local _, _, mins, sec = string.find(msg, "^(%d+):(%d+)$");
		SteakTimer_Start(tonumber(mins)*60+tonumber(sec));
	elseif ( msg == "options" ) then
		module:showModuleOptions(module.name);
	else
		SlashCmdList["TIMER"]("");
	end
end
SLASH_TIMER1 = "/timer";
SLASH_TIMER2 = "/tr";
function SteakTimer_SavePosition()
	local anchorPoint, anchorTo, relativePoint, xoffset, yoffset = SteakTimerFrame:GetPoint(1);
	if (anchorTo) then
		anchorTo = anchorTo:GetName();
	end
	local pos = { anchorPoint, anchorTo, relativePoint, xoffset, yoffset };
	module:setOption("position", pos, true);
end
function SteakTimer_RestorePosition()
	local pos = module:getOption("position");
	SteakTimerFrame:ClearAllPoints();
	if (pos) then
		SteakTimerFrame:SetPoint(pos[1], pos[2], pos[3], pos[4], pos[5]);
	else
		SteakTimerFrame:SetPoint("CENTER", UIParent, "CENTER", 0, 0);
	end
	SteakTimer_SavePosition();
end
function SteakTimer_ResetPosition()
	SteakTimerFrame:ClearAllPoints();
	SteakTimerFrame:SetPoint("CENTER", UIParent, "CENTER", 0, 0);
	SteakTimer_SavePosition();
end
function SteakTimerFrame_OnLoad(self)
	self:RegisterEvent("PLAYER_LOGIN");
end
function SteakTimerFrame_OnEvent(self, event)
	if ( event == "PLAYER_LOGIN" ) then
		SteakTimer_RestorePosition();
	end
end
local optionsFrameList;
local function optionsInit()
	optionsFrameList = module:framesInit();
end
local function optionsGetData()
	return module:framesGetData(optionsFrameList);
end
local function optionsAddFrame(offset, size, details, data)
	module:framesAddFrame(optionsFrameList, offset, size, details, data);
end
local function optionsAddObject(offset, size, details)
	module:framesAddObject(optionsFrameList, offset, size, details);
end
local function optionsAddScript(name, func)
	module:framesAddScript(optionsFrameList, name, func);
end
local function optionsBeginFrame(offset, size, details, data)
	module:framesBeginFrame(optionsFrameList, offset, size, details, data);
end
local function optionsEndFrame()
	module:framesEndFrame(optionsFrameList);
end
module.frame = function()
	local textColor1 = "0.9:0.9:0.9";
	local textColor2 = "0.7:0.7:0.7";
	local textColor3 = "0.9:0.72:0.0";
	local offset;
	local temp;
	optionsInit();
	optionsBeginFrame(-5, 0, "frame#tl:0:%y#r");
		optionsAddObject(  0,   17, "font#tl:5:%y#v:GameFontNormalLarge#Tips");
		optionsAddObject( -2, 2*14, "font#t:0:%y#s:0:%s#l:13:0#r#You can use /cttimer to open this options window directly.#" .. textColor2 .. ":l");
		optionsAddObject( -2, 2*14, "font#t:0:%y#s:0:%s#l:13:0#r#You can use /tr, or /timer, to display a list of commands in the chat window.#" .. textColor2 .. ":l");
	optionsEndFrame();
	optionsBeginFrame(-20, 0, "frame#tl:0:%y#r");
		optionsAddObject(  0,   17, "font#tl:5:%y#v:GameFontNormalLarge#General");
		optionsAddObject( -5,   26, "checkbutton#tl:30:%y#o:showTimer#Show timer");
		optionsAddObject(  6,   26, "checkbutton#tl:30:%y#o:showSeconds#Show seconds");
		optionsAddObject(  6,   26, "checkbutton#tl:30:%y#o:hideBG#Hide background");
		optionsBeginFrame( -5,   30, "button#t:0:%y#s:180:%s#n:SteakTimer_ResetPosition_Button#v:GameMenuButtonTemplate#Reset window position");
			optionsAddScript("onclick",
				function(self)
					SteakTimer_ResetPosition();
				end
			);
		optionsEndFrame();
		optionsAddObject( -5, 2*13, "font#t:0:%y#s:0:%s#l#r#This will place the window at\nthe center of the screen.#" .. textColor2);
	optionsEndFrame();
	optionsBeginFrame(-25, 0, "frame#tl:0:%y#br:tr:0:%b");
		optionsAddObject(  0,   17, "font#tl:5:%y#v:GameFontNormalLarge#Reset Options");
		optionsAddObject( -5,   26, "checkbutton#tl:20:%y#o:resetAll#Reset options for all of your characters");
		optionsBeginFrame(  -5,   30, "button#t:0:%y#s:120:%s#v:UIPanelButtonTemplate#Reset options");
			optionsAddScript("onclick", function(self)
				if (module:getOption("resetAll")) then
					Steak_TimerOptions = {};
				else
					if (not Steak_TimerOptions or not type(Steak_TimerOptions) == "table") then
						Steak_TimerOptions = {};
					else
						Steak_TimerOptions[module:getCharKey()] = nil;
					end
				end
				ConsoleExec("RELOADUI");
			end);
		optionsEndFrame();
		optionsAddObject( -7, 2*15, "font#t:0:%y#s:0:%s#l#r#Note: Resetting the options to their default values will reload your UI.#" .. textColor2);
	optionsEndFrame();
	optionsBeginFrame(-20, 0, "frame#tl:0:%y#br:tr:0:%b");
		optionsAddObject(  0,   17, "font#tl:5:%y#v:GameFontNormalLarge#Commands");
		for i, text in ipairs(SteakTimer_HELP) do
			optionsAddObject( -2, 3*14, "font#t:0:%y#s:0:%s#l:13:0#r#" .. text .. "#" .. textColor2 .. ":l");
		end
	optionsEndFrame();
	return "frame#all", optionsGetData();
end
local function optShowTimer(value)
	opts.showTimer = value;
	if (not value) then
		SteakTimerFrame:Hide();
	else
		SteakTimerFrame:Show();
	end
end
local function optShowSeconds(value)
	opts.showSeconds = value;
	SteakTimer_SetTime(SteakTimerData.time, SteakTimerFrame);
end
local function optHideBG(value)
	opts.hideBG = value;
	SteakTimerData.alphaUpdate = 5;
end
local function optsInit(value)
	SteakTimerData = module:getOption("timerData");
	if (not SteakTimerData) then
		SteakTimerData = {};
		module:setOption("timerData", SteakTimerData, true);
	end
	optShowTimer( module:getOption("showTimer") );
	optShowSeconds( module:getOption("showSeconds") );
	optHideBG( module:getOption("hideBG") );
	SteakTimerData.step = SteakTimerData.step or 1;
	SteakTimerData.time = SteakTimerData.time or 0;
	SteakTimer_SetTime(SteakTimerData.time, SteakTimerFrame);
	SteakTimerData.color = SteakTimerData.color or { 1, 0, 0 };
	SteakTimerFrameTime:SetTextColor(SteakTimerData.color[1], SteakTimerData.color[2], SteakTimerData.color[3]);
	SteakTimerGlobalFrame:Show();
end
module.optionUpdate = function(self, optName, value)
	if (optName == "init") then
		optsInit(value);
	elseif (optName == "showTimer") then
		optShowTimer(value);
	elseif (optName == "showSeconds") then
		optShowSeconds(value);
	elseif (optName == "hideBG") then
		optHideBG(value);
	end
end
module.update = function(self, optName, value)
	module.optionUpdate(self, optName, value);
end
local function slashCommand(msg)
	module:showModuleOptions(module.name);
end
module:setSlashCmd(slashCommand, "/cttimer");